
# This is a file of ASCII map methods corresponding to the ASCII maps in the old calc tool.
#Old ASCII maps are amap_3 through amap_7.  The others are new.

# NOTE:  The old calc tool worked differently in some cases than the description in the old calc
#manual described.  Known differences in the old calc tool are as follows:
#amap3 mapped numbers identical to amap4; amaps3 and 4 mapped spaces to '40';
#amap5 mapped all special characters to their ASCII equivalents.

#THE RUBY AMAPS ONLY MAP THE CHARACTERS LISTED IN EACH METHOD DESCRIPTION.

#amaps 3, 4, and 7 return strings and amaps 5 and 6 return integers

#The "puts" statements are not part of the methods.  They are for testing and comparing in this file.

box1_1 = 'A'

#This is for getting the ASCII code number for any character
puts 'ASCII code = ' + box1_1[0].to_s

#EXAMPLE OF HOW TO USE THE AMAP FUNCTIONS

#The amap method can only handle one character at a time, so the slice function must be used.
#Example of using an amap on a name code:
#name = ( box1_4.upcase.delete("^A-Z ") + ' ' * 4 )[0,4]
#amap_5(name[0,1]).to_s + amap_5(name[1,1]).to_s + amap_5(name[2,1]).to_s + amap_5(name[3,1]).to_s
#Note that amap_5 returns an integer so it has to be converted to a string before adding
#Also note that the slice function will not work on an empty string if you start with an index greater
#than zero.  box1_4[0,1] works when box1_4 is empty but box1_4[1,1] will return an error.  The above
#example works when no name is entered in box1_4 because it's being padded with 4 spaces.  If you
#have a name code that isn't padded, you will need multiple if statements to check if each index 
#postion is empty.


def amap_1(a)
#capital letters A-Z are mapped to numbers 10-35; the numbers 0-9 are mapped to 0-9
#an ampersand (&) is mapped to 36; all other special characters and lowercase letters are zero
#result is an integer
	if( a[0] != nil )
		if( a[0] > 64 ) and ( a[0] < 91 ) then a[0] - 55
		elsif( a[0] > 47 ) and ( a[0] < 58 ) then a[0] - 48
		elsif a[0] == 38 then 36
		else 0
		end
	else 0
	end
end

puts 'amap_1 = ' + amap_1(box1_1).to_s


def amap_2(a)
#capital letters A-Z are mapped to the two-digit numbers 01-26; a comma is mapped to 27;
#a hyphen is mapped to 28; an apostrophe is mapped to 29; numbers, lowercase letters, and
#all other special characters are two zeros
#result is a string
	if( a[0] != nil )
		if( a[0] > 64 ) and ( a[0] < 91 ) then '%02.0f' % ( a[0] - 64 )
		elsif a[0] == 44 then '27'
		elsif a[0] == 45 then '28'
		elsif a[0] == 39 then '29'
		else '00'
		end
	else '00'
	end
end

puts 'amap_2 = ' + amap_2(box1_1)


def amap_3(a)
#capital letters A-Z are mapped to the two-digit numbers 01-26;
#numbers, special characters, and lowercase letters are two zeros
#result is a string
	if( a[0] != nil )
		if( a[0] < 65 ) or ( a[0] > 90 ) then '00'
		else '%02.0f' % ( a[0] - 64 )
		end
	else '00'
	end
end

puts 'amap_3 = ' + amap_3(box1_1)


def amap_4(a)
#capital letters A-Z are mapped to the two-digit numbers 01-26; the numbers 0-9 are mapped
#to the numbers 30-39; special characters and lowercase letters are two zeros
#result is a string
	if( a[0] != nil )
		if( a[0] > 47 ) and ( a[0] < 58 ) then '%02.0f' % ( a[0] - 18 )
		elsif( a[0] < 65 ) or ( a[0] > 90 ) then '00'
		else '%02.0f' % ( a[0] - 64 )
		end
	else '00'
	end
end

puts 'amap_4 = ' + amap_4(box1_1)


def amap_5(a)
#capital letters A-Z are mapped to numbers 65-90; the numbers 0-9 are mapped to numbers 48-57;
#an ampersand (&) is mapped to 38; a space to 32; a dash to 45;
#all other special characters and lowercase letters are zero
#result is an integer
	if( a[0] != nil )
		if( a[0] > 64 ) and ( a[0] < 91 ) then a[0]
		elsif( a[0] > 47 ) and ( a[0] < 58 ) then a[0]
		elsif a[0] == 45 then 45
		elsif a[0] == 38 then 38
		elsif a[0] == 32 then 32
		else 0
		end
	else 0
	end
end

puts 'amap_5 = ' + amap_5(box1_1).to_s


def amap_6(a)
#capital letters A-I and J-R are mapped to numbers 1-9; letters S-Z are mapped to numbers 2-9;
#the numbers 0-9 are mapped to numbers 0-9; special characters and lowercase letters are zero
#result is an integer
	if( a[0] != nil )
		if( a[0] > 47 ) and ( a[0] < 58 ) then a[0] - 48
		elsif( a[0] < 65 ) or ( a[0] > 90 ) then 0
		elsif( a[0] < 74 ) then a[0] - 64
		elsif a[0] < 83 then a[0] - 73
		else a[0] - 81
		end
	else 0
	end
end

puts 'amap_6 = ' + amap_6(box1_1).to_s


def amap_7(a)
#capital letters A-Z are mapped to numbers 10-35; the numbers 0-9 are mapped to
#the two-digit numbers 00-09; an ampersand (&) is mapped to 36;
#all other special characters and lowercase letters are two zeros
#result is a string
	if( a[0] != nil )
		if( a[0] > 64 ) and ( a[0] < 91 ) then '%02.0f' % ( a[0] - 55 )
		elsif( a[0] > 47 ) and ( a[0] < 58 ) then '%02.0f' % ( a[0] - 48 )
		elsif a[0] == 38 then '36'
		else '00'
		end
	else '00'
	end
end

puts 'amap_7 = ' + amap_7(box1_1)


def amap_8(a)
#capital letters A-Z are mapped to numbers 10-35; the numbers 0-9 are mapped to 0-9
#an ampersand (&) is mapped to 36; all other special characters and lowercase letters are 37
#result is an integer
	if( a[0] != nil )
		if( a[0] > 64 ) and ( a[0] < 91 ) then a[0] - 55
		elsif( a[0] > 47 ) and ( a[0] < 58 ) then a[0] - 48
		elsif a[0] == 38 then 36
		else 37
		end
	else 0
	end
end

puts 'amap_8 = ' + amap_8(box1_1).to_s


def amap_9(a)
#capital letters A-I are mapped to numbers 1-9; J is zero; K-S are 1-9 ; T is zero; U-Z are 1-6
#the numbers 0-9 are mapped to numbers 0-9; special characters and lowercase letters are zero
#result is an integer
	if( a[0] != nil )
		if( a[0] > 47 ) and ( a[0] < 58 ) then a[0] - 48
		elsif( a[0] < 65 ) or ( a[0] > 90 ) then 0
		elsif( a[0] > 64 ) and ( a[0] < 74 ) then a[0] - 64
		elsif( a[0] > 74 ) and ( a[0] < 84 ) then a[0] - 74
		elsif( a[0] > 84 ) and ( a[0] < 91 ) then a[0] - 84
		else 0
		end
	else 0
	end
end

puts 'amap_9 = ' + amap_9(box1_1).to_s




def amap_10(a)
#capital letters A-Z are mapped to numbers 10-35; the numbers 0-9 are mapped to 0-9
#an ampersand (&) is mapped to 36; a space is mapped to 0; and all other special characters are 37
#result is an integer
	if( a[0] != nil )
		if( a[0] > 64 ) and ( a[0] < 91 ) then a[0] - 55
		elsif( a[0] > 47 ) and ( a[0] < 58 ) then a[0] - 48
		elsif a[0] == 38 then 36
		elsif a[0] == 32 then 0	
		else 37
		end
	else 0
	end
end

puts 'amap_10 = ' + amap_10(box1_1).to_s




def delaware_amap(a)
#The numbers 1-9 are mapped to 1-9; a zero is mapped to 10; the letters A-H are 11-18; J-N are 19-23;
#P-R are 24-26; T-U are 27-28; W-Y are 29-31; the letters I,O,S,V, and Z are mapped to zero because
#Delaware wants them to take an index position in the scanline but not compute a value.
#There should be no other characters in the Delaware scanline, but anything else defaults to a zero. 
#result is an integer
	if( a[0] != nil )
		if( a[0] > 64 ) and ( a[0] < 73 ) then a[0] - 54
		elsif( a[0] > 73 ) and ( a[0] < 79 ) then a[0] - 55
		elsif( a[0] > 79 ) and ( a[0] < 83 ) then a[0] - 56
		elsif( a[0] > 83 ) and ( a[0] < 86 ) then a[0] - 57
		elsif( a[0] > 86 ) and ( a[0] < 90 ) then a[0] - 58
		elsif( a[0] > 48 ) and ( a[0] < 58 ) then a[0] - 48
		elsif a[0] == 48 then 10
		else 0
		end
	else 0
	end
end

puts 'delaware_amap = ' + delaware_amap(box1_1).to_s


#The following method is for the Delaware forms that allow the check digit to be a letter as well as a number.  It is the opposite of the delaware_amap that is above.
#It requires you to modify the check digit function to allow for a double digit result.  Refer to DE12257F for an example.

def delaware_cd(a)
#This is the reverse of the above delaware_amap method to convert the cd method result to the Delaware check digit.
#result is a string
	ascii_value = if( a > 10 ) and ( a < 19 ) then a + 54
			elsif( a >= 19 ) and ( a < 24 ) then a + 55
			elsif( a >= 24 ) and ( a < 27 ) then a + 56
			elsif( a >= 27 ) and ( a < 29 ) then a + 57
			elsif( a >= 29 ) and ( a < 32 ) then a + 58
			elsif( a >= 1 ) and ( a < 10 ) then a + 48
			elsif a == 10 then 48
			else 0
			end
#The chr turns the ASCII number back into a character.
( ascii_value == 0 ? '0' : ascii_value.chr )
end




def fed_amap(a)
#capital letters A-Z are mapped to numbers 10 - 35; the numbers 0-9 are mapped to 0-9
#a hyphen is mapped to 36; a period is mapped to 37; space 38; dollar 39; slash (/) 40; plus 41; percent 42;
#and all other special characters and lowercase letters are 0  
#result is an integer
	if( a[0] != nil )
		if( a[0] > 47 ) and ( a[0] < 58 ) then a[0] - 48
		elsif( a[0] > 64 ) and ( a[0] < 91 ) then a[0] - 55
		elsif a[0] == 32 then 38
		elsif a[0] == 36 then 39
		elsif a[0] == 37 then 42	
		elsif a[0] == 43 then 41		
		elsif a[0] == 45 then 36
		elsif a[0] == 46 then 37	
		elsif a[0] == 47 then 40
		else 0
		end
	else 0
	end
end


puts 'fed_amap = ' + fed_amap(box1_1).to_s


def fed5500_cd(a)
#capital letters A-Z are mapped to numbers 10-35; the numbers 0-9 are mapped to 0-9
#a hyphen is mapped to 45; a period is mapped to 46; space 32; dollar 36; slash (/) 45; plus 43; percent 37;
#and all other special characters and lowercase letters are 0
#This is the reverse of the above fed_amap method to convert the cd method result to the Federal 5500 check digit.
#result is a string
	ascii_value = if( a < 10 ) then a + 48
			elsif( a > 9 ) and ( a < 36 ) then a + 55
			elsif a == 36 then 45
			elsif a == 37 then 46	
			elsif a == 38 then 32
			elsif a == 39 then 36
			elsif a == 40 then 47
			elsif a == 41 then 43
			elsif a == 42 then 37		
			else 0
			end

#The chr turns the ASCII number back into a character.
( ascii_value == 0 ? '0' : ascii_value.chr )
end



def utah_amap(a)
#capital letters A-Z are mapped to numbers 1-26; the numbers 0-9 are mapped to 0-9
#special characters and lowercase letters are zero
#result is an integer
	if( a[0] != nil )
		if( a[0] > 64 ) and ( a[0] < 91 ) then a[0] - 64
		elsif( a[0] > 47 ) and ( a[0] < 58 ) then a[0] - 48
		else 0
		end
	else 0
	end
end

puts 'utah_amap = ' + utah_amap(box1_1).to_s













